# -*- coding: utf-8 -*-

#1a) Si scriva una funzione count_codons(orf, prot) che, date in 
# input due stringhe corrispondenti all'ORF (Open Reading Frame) e alla 
# sequenza peptidica relative presumibilmente alla stessa proteina, 
# restituisca un dizionario con chiavi tutti i possibili valori dei codoni, e 
# i cui valori corrispondono al numero di occorrenze di tale codone nell'ORF. 
# Un ORF deve sempre iniziare con un codone di start e terminare con un codone 
# di stop.
# Nel caso in cui 'orf' e 'prot' non siano tra loro corrispondenti, la 
# funzione dovrà restituire None; nel caso in cui prot sia None, il controllo 
# di corrispondenza non dovrà essere fatto.
# Si faccia riferimento al codice genetico presente sotto forma di dizionario 
# nel file gen_datastructs.py; la traduzione di un codone di stop è per 
# convenzione '_'; prot può terminare sia esplicitamente che implicitamente 
# con '_'
#
# Es: count_codons("AT","MTPP") --> None
#     count_codons("GTGACCACTCCCTAA","MTPP")  --> None
#     count_codons("ATGACCCCTCCCTAA","MTPP")  --> ok, returns the correct dict
#     count_codons("ATGACCCCTCCCTAA","MTPP_") --> ok, returns the correct dict
#     count_codons("ATGACCCCTCCC","MTPP")     --> None (missing stop codon)

from gen_datastructs import gen_code

def count_codons(orf, prot=None):
    if len(orf)%3:
        return None
    res={ x: 0 for x in gen_code}
    codon_vals=[orf[i:i+3] for i in xrange(0,len(orf),3)]
    if prot is None:
        for c in codon_vals:
            res[c]+=1        
    else:
        if prot[-1]!='_':
            prot+='_'
        if len(codon_vals)!=len(prot):
            return None
        for c,a in zip(codon_vals, prot):
            if not a == gen_code[c]:
                return None
            res[c]+=1
    return res
            