# -*- coding: utf-8 -*-

#2a) Ogni singolo amminoacido può essere codificato da più codoni.
# Sfruttando possibilmente il codice scritto per l'esercizio precedente, si 
# scriva una funzione details_comp(orf, prot) che prenda in input gli stessi 
# dati già descritti per "count_codons(orf, prot)" e che si comporti come essa 
# riguardo ai casi di non corrispondenza tra e sequenze fornite. Inoltre, 
# details_comp dovrà fornire in uscita un dizionario le cui chiavi siano i 
# simboli a un solo carattere degli amminoacidi, più '_' per lo stop, e i cui 
# valori siano liste che contengono tante tuple quanti sono i valori distinti 
# dei codoni codificanti tale amminoacido; ciascuna tupla deve contenere il 
# valore specifico del codone, e il suo numero di occorrenze nell'ORF.
#
# Es: x = details_comp("ATGACCCCTCCCTAA","MTPP")
#     x['P'] --> [('CCA', 0), ('CCC', 1), ('CCG', 0), ('CCT', 1)]
#     x['_'] --> [('TAA', 1), ('TAG', 0), ('TGA', 0)]


from gen_datastructs import code_gen
from gen_datastructs import gen_code
from soluzione1 import count_codons


def details_comp(orf, prot):
    occurr = count_codons(orf, prot)
    if occurr is None:
        return occurr
    aa_symbols=code_gen.keys()
    clist={s:[] for s in aa_symbols}
    iterlist=gen_code.items()
    iterlist.sort()
    for c,a in iterlist:
        clist[a].append((c,occurr[c]))
    return clist
