# -*- coding: utf-8 -*-

#4a) Si assuma che, data una qualsiasi sequenza di nucleotidi, si possa 
# rintracciare al suo interno un ORF identificando un codone di start 'ATG' e, 
# nello stesso "reading frame", un successivo codone di stop (tra i possibili 
# tre).
# Si scriva la funzione uncover_orf(seq) che, su una stringa di basi 'seq', 
# trovi gli indici di partenza (incluso) e di terminazione (escluso) del  più 
# lungo ORF contenuto in essa. Si desidera che la funzione restituisca una 
# lista di tuple, in ognuna delle quali viene riportata la lunghezza dell'ORF, 
# l'indice iniziale e l'indice finale (con convenzione Python).
#
# Es: s="TGATGCATGACACCTGGTGGTCCTGAATAAT"
#     uncover_orf(my_seq) --> [(24, 6, 30), (24, 2, 26)]


def uncover_orf(seq):
    l=len(seq)
    start='ATG'
    stops=['TAG','TAA','TGA']
    candidates=[]
    i=0
    nextpos=l
    while nextpos>=0:
        nextpos=seq.find(start,i,-1)
        if nextpos>=0:
            #the corresponding stop to be looked for in the same reading frame
            for j in xrange(nextpos, l, 3):
                if seq[j:j+3] in stops:
                    candidates.append((j-nextpos+3,nextpos,j+3))
                    break
            i=nextpos+1
    candidates.sort(reverse=True)
    if candidates:
        maxlen=candidates[0][0]
        for c in candidates[:]:
            if c[0]<maxlen:
                candidates.remove(c)
    return candidates
